freeslot("sfx_fboom", "sfx_fchaos", "sfx_fpoop", "sfx_fqjmp", "sfx_fhomg", "sfx_fclap", "sfx_fadve")

sfxinfo[sfx_fboom].caption = "Chaos Breaker!"
sfxinfo[sfx_fchaos].caption = "Chaos Control!"
sfxinfo[sfx_fhomg].caption = "QUAD JUMP"
sfxinfo[sfx_fqjmp].caption = "Homing Attack"
sfxinfo[sfx_fclap].caption = "HELP ME! OH MY GOOOOOD!!!"
sfxinfo[sfx_fpoop].caption = "Poggers."
sfxinfo[sfx_fadve].caption = "ADVENTURE!"

local kirbyabilityadded = false
addHook("ThinkFrame", function()
    if not(kirbyabilityadded)
    and(K_AddAbility)
        kirbyabilitytable["loafy"] = 15
        kirbyabilityadded = true
    end
end)

//Ability Swap
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin ~= "loafy" then
			continue
		end

		if player.cmd.buttons & BT_CUSTOM1
			if not player.pressedcustom1
				if player.charability == CA_HOMINGTHOK
					player.charability = CA_DOUBLEJUMP
					player.actionspd = 2*FRACUNIT
					S_StartSound(player.mo, sfx_fhomg)
					player.pressedcustom1 = true
				elseif player.charability == CA_DOUBLEJUMP
					player.charability = CA_HOMINGTHOK
					player.actionspd = 100*FRACUNIT
					S_StartSound(player.mo, sfx_fqjmp)
					player.pressedcustom1 = false
				end
			end
			player.pressedcustom1 = true
		else
			player.pressedcustom1 = false
		end

		if player.spawnedmonitor and player.spawnedmonitor.valid then
			local xdiff = player.spawnedmonitor.x-player.mo.x
			local ydiff = player.spawnedmonitor.y-player.mo.y
			local zdiff = player.spawnedmonitor.z-player.mo.z
		end

		if player.cmd.buttons & BT_FIRENORMAL and player.cmd.buttons & BT_TOSSFLAG
			if not player.c2down
					S_StartSound(player.mo, sfx_fclap)
					player.c2down = true
			end
		else
			player.c2down = false
		end
	
		if player.cmd.buttons & BT_USE and player.cmd.buttons & BT_TOSSFLAG
			if not player.c3down
					S_StartSound(player.mo, sfx_fadve)
					player.c3down = true
			end
		else
			player.c3down = false
		end
	end
end)

//Explosion Ability
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin ~= "loafy" then
			continue
		end
				
		if not (player.cmd.buttons & BT_CUSTOM2) then
			player.monspawntapready = true
			player.monspawntapping = false
		elseif player.monspawntapready then
			player.monspawntapping = true
			player.monspawntapready = false
		else
			player.monspawntapping = false
		end

		if player.spawnedmonitor and player.spawnedmonitor.valid then
			local xdiff = player.spawnedmonitor.x-player.mo.x
			local ydiff = player.spawnedmonitor.y-player.mo.y
			local zdiff = player.spawnedmonitor.z-player.mo.z
		end
			
		if player.cmd.buttons & BT_CUSTOM2 and player.rings > 20 and emeralds & EMERALD2
			if not player.c2down
				player.mo.state = S_PLAY_SUPER_TRANS1
					S_StartSound(player.mo, sfx_fboom)
					P_NukeEnemies(player.mo, player.mo, 1500*FRACUNIT)
					P_GivePlayerRings(player, -20)
					player.c2down = true
			end
		else
			player.c2down = false
		end
	end
end)

//Teleport to nearest player
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin ~= "loafy" then
			continue
		end
				
		if not (player.cmd.buttons & BT_CUSTOM3) then
			player.monspawntapready = true
			player.monspawntapping = false
		elseif player.monspawntapready then
			player.monspawntapping = true
			player.monspawntapready = false
		else
			player.monspawntapping = false
		end
		
		if player.cmd.buttons & BT_CUSTOM3 and player.rings > 30 and emeralds & EMERALD2
			if not player.c3down
				player.mo.state = S_PLAY_SUPER_TRANS1
				local nearest
				local mindist = INT32_MAX
				for p2 in players.iterate do
					if player == p2 then continue end
					local dist = R_PointToDist2(3*FRACUNIT, 3*FRACUNIT, 3*FRACUNIT, 3*FRACUNIT)
					if (dist < mindist) then
						nearest = p2
						mindist = dist
					end
				end
				if (nearest) then
					P_TeleportMove(player.mo, nearest.mo.x, nearest.mo.y, nearest.mo.z)
					S_StartSound(player.mo, sfx_fchaos)
					P_GivePlayerRings(player, -30)
				local fwoosh = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
					fwoosh.state = S_FORC21
					fwoosh.fuse = 8
					player.c3down = true
				end
			end
		else
			player.c3down = false
		end
	end
end)